//
//  ebp.c
//  matricesStructuresAllocationDynamique
//
//  Created by soldano on 14/09/2014.
//  Copyright (c) 2014 soldano. All rights reserved.
//
// Primitives de reconnaissance d'une expression ebp dans une chaine
// a partir de 0 :
// ebp -> symbole // dans s_symbole
// ebp -> (ebp operateur-unaire) // dans s_op1
// ebp -> (ebp operateur-binaire ebp) // dans s_op2
// La position p dans l'expression commence en 1 : s[p-1] est le symbole en
// position p dans l'expression

#include "ebp.h"

int ebp_c(char s[], char s_symbole[], char s_op1[], char s_op2[]){
    /* 1 si s contient a partir de 0  une ebp et 0 sinon */
    int p;
    p=ebp(1,s,s_symbole,s_op1,s_op2);
    if(p >=1){// l'expression bien forme'e finit en p-1 dans s
        if (s[p]=='\0' ) // pas d'autres caracte`res dans la chai^ne
            return 1;// ebf
        printf("erreur en position %d dans la chaine\n",p);// caracte`re en trop
        return 0;
    }
    printf("erreur en position %d dans la chaine\n",(-p)-1);// erreur dans l'expression
    return 0;
}

int ebp(int p, char s[], char s_symbole[], char s_op1[], char s_op2[]){
    /* si ebp commençant en position p (i.e. en s[p-1]) renvoie la position p de
     fin de l'ebp  ou echec (-p) avec erreur en position p )               */
    if (symbole(p,s,s_symbole))
        return p; // ebp
    if (! ouvrante (p,s))
        return -p; // erreur
    p=p+1;// avance
    p=ebp(p,s,s_symbole,s_op1,s_op2);
    if(p<0) return p;// erreur
    p=p+1;
    if(op1(p,s,s_op1)); // oui
    else if(op2(p,s,s_op2)){ // oui
        p=p+1; p=ebp(p,s,s_symbole,s_op1,s_op2); if(p<0) return p; // erreur
    }
    else
        return -p;//erreur
    p=p+1;
    if (! fermante (p,s))
        return -p;// erreur
    return p; // ebp
}

int symbole(int p, char s[], char s_symbole[]){
    /* Renvoie 1 si s[p-1] est dans la chaine s_symbole et 0 sinon */
    return charDans(s[p-1], s_symbole);
}
int op1(int p, char s[], char s_op1[]){
    return charDans(s[p-1], s_op1);
}
int op2(int p, char s[], char s_op2[]){
    return charDans(s[p-1], s_op2);
}
int ouvrante(int p, char s[]){
    if (s[p-1]=='(')
        return 1;
    return 0;
}
int fermante(int p, char s[]){
    if (s[p-1]==')')
        return 1;
    return 0;
}
int charDans(char c, char s[]){
    // Renvoie 1 si c est dans s;
    int i;
    
    i=0;
    while (s[i] !='\0') {
        if (c==s[i]) {
            return 1;
        }
        i++;
    }
    return 0;
}