//
//  main.c
//  matricesStructuresAllocationDynamique
//
//  Created by soldano on 07/09/2014.
//  Copyright (c) 2014 soldano. All rights reserved.
//

/*
 calcul matriciel avec structures et allocation dynamique du tableau
 */
#include <stdio.h>
#include <stdlib.h>
#include "ebp.h"
#include "matrices.h"


/*  types  */

/* prototypes */
void calculette();
matrice_t evaluation();
matrice_t calcul(matrice_t tabMat[], int nombre);
matrice_t evaluationChaine(int* apos,char s[],matrice_t tabMat[10]);



/* fonction principale */
int main () {
    /*   Calcul à partir de primitives de calcul matriciel avec structures */
    matrice_t mr;
    matrice_t tabMat[10];
    int n;
    int choix;
    
    printf("calculette sans me'morisation (peigne gauche) (1) ou \n");
    printf("calculette avec me'morisation (2) ou \n");
    printf("calcul à partir d'un tableau de matrices et d'une expression (3)\n");
    scanf("%d",&choix);
    if (choix==1) {
        calculette();
    }
    if (choix==2) {
        printf("Calcul matriciel (les sommets de l'arbre en ordre pre'fixe)\n");
        mr=evaluation();
        printf("Re'sultat du calcul\n");
        afficheMatrice(mr);
    }
    if (choix==3){
        printf("dimension d'une matrice carrée?");
        scanf("%d",&n);
        printf("matrice %d lignes %d colonnes ?\n",n,n);
        tabMat[0]=lireMatrice(n,n);
        printf("matrice %d lignes %d colonnes ?\n",n,n);
        tabMat[1]=lireMatrice(n,n);
        while (choix!=0) {
            printf("expression d'un calcul matriciel sur deux matrices carre'es 0 et 1\n");
            mr=calcul(tabMat,2);
            if (mr.nl!=0)
                afficheMatrice(mr);
            printf("autre expression  (1) ou fin (0) ?\n");
            scanf("%d",&choix);
        }

    }
    return 0;
}
/* fonctions    */

void calculette()
{
    /* calculette sans me'moire (l'arbre est un peigne gauche */
    matrice_t m1,m2,mr;
    int nl1,nc1;
    int nl2,nc2;
    char ch[2]; // on lira l'operateur dans une chaine de longueur 1
    char op;
    
    //
    printf("nb lignes, nb de colonnes  et elements ?\n");
    scanf("%d",&nl1);
    scanf("%d",&nc1);
    m1=lireMatrice(nl1,nc1);
    printf("operateur ? + * t ou # pour finir\n");
    scanf("%s",ch);op=ch[0];
    while(op != '#'){
        if (op == '+'){

            printf("matrice %d lignes %d colonnes ?\n",m1.nl,m1.nc);
            m2=lireMatrice(m1.nl, m1.nc);
            mr=sommeMatrices(m1,m2);
        }
        else if (op == '*'){
            printf("nb de colonnes de la matrice ? \n");
            scanf("%d",&nc2);
            nl2=m1.nc;
            printf("matrice %d lignes %d colonnes ?\n",nl2,nc2);
            m2=lireMatrice(nl2, nc2);
            mr=produitMatrices(m1,m2);
        }
        else if (op =='t'){
            mr=transpose(m1);
        }
        detruitMatrice(m1); // on libere la memoire allouee au tableau dans m1
        m1=mr;
    
        printf("matrice %d lignes %d colonnes \n",m1.nl,m1.nc);
        afficheMatrice(m1);
        printf("operateur ? + * t ou # pour finir\n");
        scanf("%s",ch);op=ch[0];
    }
    //    afficheMatrice(m1, nl1, nc1);
    return;
}

matrice_t evaluation()
{
    /* calculette avec me'moire (l'arbre est quelconque) */
    /* la fonction est récursive                        */

    char ch[2];
    char op;
    matrice_t m1,m2,m;
    //
    printf("operateur ? + * t ou m pour finir\n");
    scanf("%s",ch);op=ch[0];


    if (op == 'm'){
        printf("nb lignes, nb de colonnes  et elements ?\n");
        scanf("%d",&m.nl);
        scanf("%d",&m.nc);
//        printf("matrice %d lignes %d colonnes ?\n",m1.nl,m1.nc);
        m=lireMatrice(m.nl, m.nc);
    }
    if (op == '+') {
        m1=evaluation();
        m2=evaluation();
        m=sommeMatrices(m1,m2);
        detruitMatrice(m1);
        detruitMatrice(m2);
    }
    if (op == '*') {
        m1=evaluation();
        m2=evaluation();
        m=produitMatrices(m1,m2);
        detruitMatrice(m1);
        detruitMatrice(m2);
    }
    if (op == 't') {
        m1=evaluation();
        m=transpose(m1);
        detruitMatrice(m1);
    }
    printf(" matrice courante \n");
    afficheMatrice(m);
    return m;
}

matrice_t calcul(matrice_t tabMat[], int nombre)
{
    /* calcul matriciel : on un tableau 'tabMat' de  taille 'nombre'
     de matrices   et on entre une  expression bien forme'e parenthe'se'e (ebp) sous forme infixe,
     dans laquelle les matrices sont repre'sente'es par leur
     indice entre 0 et nombre-1 dans tabMat (nombre <=10) 
     Exemple : 
     si nombre =2
     (((0+1)+((0+0)+(1+1)))t) est correcte
     (((0+1)+((0+2)+(1+1))), (((0t1)+((0+)+(1+1))))))  sont incorrectes
    */
    char s_symb[10];
    char *s_symbole="0123456789";
    char *s_op1="t";
    char *s_op2="+*";
    int i;
    char ch[1000];// contient l'expression, de'but en 0
    matrice_t m; // le resultat
    int pos=0; // la  position de l'e'lement courant dans la chai^ne
    //
    for (i=0;i<nombre ; i++) {
        s_symb[i]=s_symbole[i];
    }
    s_symb[i]='\0';
    printf("entrez en ordre infixe l'expression\n");
    scanf("%s",ch);
    if(! ebp_c(ch,s_symb,s_op1,s_op2)){
        m.nc=m.nl=0;
        return m;
    }
    // l'expression est correcte
    m=evaluationChaine(&pos,ch,tabMat);
    return m;
}

matrice_t evaluationChaine(int *apos,char s[],matrice_t tabMat[])
{
    /* Appele'e par 'calcul' evalue l'expression ebp qui commence en (*apos) dans la chai^ne s
     Par exemple dans (((0*1)+((1+1)*(0+1)))t), en 2 commence l'expression (0+1)
     */
    matrice_t m,m1,m2;
    int i,pos;
    pos=(*apos);
    // si '(' calculer une sous-expression
    if (s[pos]=='('){
        (*apos)=(*apos)+1;
        m1=evaluationChaine(apos, s, tabMat);// on evalue l'argument gauche
//        afficheMatrice(m1);
        (*apos)=(*apos)+1;  // on avance d'une position après la position de
                            // fin de l'expression evalue'e en m1
        pos=(*apos);
        if (s[pos]=='+'){//
//             printf("%d\n",(*apos));
            (*apos)=(*apos)+1; // on avance
            m2=evaluationChaine(apos, s, tabMat);
//            afficheMatrice(m2);
            m=sommeMatrices(m1, m2);
        }
        if (s[pos]=='*'){//
            //             printf("%d\n",(*apos));
            (*apos)=(*apos)+1; // on avance
            m2=evaluationChaine(apos, s, tabMat);
            //            afficheMatrice(m2);
            m=produitMatrices(m1, m2);
        }
        if (s[pos]=='t'){//
            m=transpose(m1);
        }

        (*apos)=(*apos)+1; // on lit la ')'
        return m;
    }
    // sinon s[pos] est un entier représentant une matrice
    i= -48+(int)s[pos];
    m=tabMat[i];
    return m;
}


/*
----------
calculette sans me'morisation (peigne gauche) (0) ou
calculette avec me'morisation (1) ou
calcul à partir d'un tableau de matrices et d'une expression (2)
1
nb lignes, nb de colonnes  et elements ?
2 2
1 2
3 4
operateur ? + * t ou # pour finir
*
nb de colonnes de la matrice ?
2
matrice 2 lignes 2 colonnes ?
2 0 
0 2
matrice 2 lignes 2 colonnes
2 4
6 8
operateur ? + * t ou # pour finir
#
Program ended with exit code: 0
--------------
 calculette sans me'morisation (peigne gauche) (0) ou
 calculette avec me'morisation (1) ou
 calcul à partir d'un tableau de matrices et d'une expression (2)
 2
 Calcul matriciel (les sommets de l'arbre en ordre pre'fixe)
 operateur ? + * t ou m pour finir
 +
 operateur ? + * t ou m pour finir
 t
 operateur ? + * t ou m pour finir
 m
 nb lignes, nb de colonnes  et elements ?
 2 2
 1 2
 3 4
 matrice courante
 1 2
 3 4
 matrice courante
 1 3
 2 4
 operateur ? + * t ou m pour finir
 *
 operateur ? + * t ou m pour finir
 +
 operateur ? + * t ou m pour finir
 m
 nb lignes, nb de colonnes  et elements ?
 2 2
 1 2
 3 4
 matrice courante
 1 2
 3 4
 operateur ? + * t ou m pour finir
 m
 nb lignes, nb de colonnes  et elements ?
 2 2
 1 0
 0 1
 matrice courante
 1 0
 0 1
 matrice courante
 2 2
 3 5
 operateur ? + * t ou m pour finir
 m
 nb lignes, nb de colonnes  et elements ?
 2 2
 1 2
 3 4
 matrice courante
 1 2
 3 4
 matrice courante
 8 12
 18 26
 matrice courante
 9 15
 20 30
 Re'sultat du calcul
 9 15 
 20 30 
 Program ended with exit code: 0
 -------------------------
 calculette sans me'morisation (peigne gauche) (1) ou
 calculette avec me'morisation (2) ou
 calcul à partir d'un tableau de matrices et d'une expression (3)
 3
 dimension d'une matrice carrée?2
 matrice 2 lignes 2 colonnes ?
 1 2 
 3 4
 matrice 2 lignes 2 colonnes ?
 1 3 
 2 4
 expression d'un calcul matriciel sur deux matrices carre'es 0 et 1
 entrez en ordre infixe l'expression
 (0+(1+))
 erreur en position 6 dans la chaine
 autre expression  (1) ou fin (0) ?
 (0+(1t))
 expression d'un calcul matriciel sur deux matrices carre'es 0 et 1
 entrez en ordre infixe l'expression
 2 4
 6 8
 autre expression  (1) ou fin (0) ?
 0
 Program ended with exit code: 0
 */