//
//  main.c
//  matricesStructuresAllocationDynamique
//
//  Created by soldano on 07/09/2014.
//  Copyright (c) 2014 soldano. All rights reserved.
//

/*
 calcul matriciel avec structures et allocation dynamique du tableau
 */
#include <stdio.h>
#include <stdlib.h>



/*  types  */

struct Matrice{
    int  **t;
    int nl;
    int nc;
} ;

typedef struct Matrice matrice_t;

/* prototypes */

// primitives de calcul matriciel avec structures
matrice_t construitMatrice(int nl, int nc);
matrice_t dupliqueMatrice(matrice_t m);
matrice_t lireMatrice(int nl, int nc);
void afficheMatrice(matrice_t m);
matrice_t produitMatrices(matrice_t m1, matrice_t m2);
matrice_t sommeMatrices(matrice_t m1, matrice_t m2);
matrice_t transpose(matrice_t m);
void detruitMatrice(matrice_t m);
void calculette();
matrice_t evaluation();
matrice_t calcul(matrice_t tabMat[], int nombre);
matrice_t evaluationChaine(int* apos,char s[],matrice_t tabMat[10]);
int ebp_c(char s[]);
int ebp(int p, char s[]);
int symbole(int p, char s[]);
int op1(int p, char s[]);
int op2(int p, char s[]);
int ouvrante(int p, char s[]);
int fermante(int p, char s[]);


/* fonction principale */
int main () {
    /*   Calcul à partir de primitives de calcul matriciel avec structures */
    matrice_t mr;
    matrice_t tabMat[10];
    int n;
    int choix;
    
    printf("calculette sans me'morisation (peigne gauche) (1) ou \n");
    printf("calculette avec me'morisation (2) ou \n");
    printf("calcul à partir d'un tableau de matrices et d'une expression (3)\n");
    scanf("%d",&choix);
    if (choix==1) {
        calculette();
    }
    if (choix==2) {
        printf("Calcul matriciel (les sommets de l'arbre en ordre pre'fixe)\n");
        mr=evaluation();
        printf("Re'sultat du calcul\n");
        afficheMatrice(mr);
    }
    if (choix==3){
        printf("dimension d'une matrice carrée?");
        scanf("%d",&n);
        printf("matrice %d lignes %d colonnes ?\n",n,n);
        tabMat[0]=lireMatrice(n,n);
        printf("matrice %d lignes %d colonnes ?\n",n,n);
        tabMat[1]=lireMatrice(n,n);
        while (choix!=0) {
            printf("expression d'un calcul matriciel sur deux matrices carre'es 0 et 1\n");
            mr=calcul(tabMat,2);
            if (mr.nl!=0)
                afficheMatrice(mr);
            printf("autre expression  (1) ou fin (0) ?\n");
            scanf("%d",&choix);
        }

    }
    return 0;
}
/* fonctions    */
matrice_t construitMatrice(int nl, int nc)
{
    /* construit une matrice de dimensions nl nc */
    int i;
    matrice_t m;
    
    m.nl=nl;
    m.nc=nc;
    m.t=(int **) malloc(m.nl*sizeof(int*));//alloue un tableau de nl tableaux
    
    for (i=0;i<m.nl;i++){
        m.t[i]= (int *) malloc (m.nc* sizeof (int));
    }
    return m;
}

matrice_t dupliqueMatrice(matrice_t m)
{
    /* duplique la matrice m */
    /* m2=dupliqueMatrice(m1) permet de copier m1 dans m2 */
    /* sans que les modifications (ensuite) de m2 ne modifient également m1 */
    int i,j;
    matrice_t md;
    //
    md=construitMatrice(m.nl, m.nc);
    for (i=0; i<md.nl; i++)
        for (j=0; j<md.nc; j++)
            md.t[i][j]=m.t[i][j];
    return md;
}


void detruitMatrice(matrice_t m)
{
    /* desalloue la mémoire de la matrice m */
    int i;
    //
    for (i=0; i<m.nl; i++)
        free(m.t[i]);
    free(m.t);
    m.nl=0;
    m.nc=0;
    return ;
}

matrice_t lireMatrice(int nl, int nc)
{
    /* Alloue, lit et renvoie une matrice de dimensions nl nc */
    int i,j;
    matrice_t m;
    
    m=construitMatrice(nl,nc);
    
    for (i=0;i<m.nl;i++){
        for (j=0;j<m.nc;j++){
            scanf("%d",&m.t[i][j]);
        }
    }
//    printf("fin\n");
    return m;
}

void afficheMatrice(matrice_t m)
{
    /* affiche la matrice m */
    int i,j;
    for (i=0;i<m.nl;i++){
        for (j=0;j<m.nc;j++){
            printf("%d ",m.t[i][j]);
        }
        printf("\n");
    }
    return;
    
}


matrice_t produitMatrices(matrice_t m1, matrice_t m2)
{
    /* renvoie le produit de deux matrices m1 et m2 */
    int i,j,k;
    matrice_t mr;
    mr=construitMatrice(m1.nl,m2.nc);
    for (i=0;i<mr.nl;i++){
        for (j=0;j<mr.nc;j++){
            mr.t[i][j]=0;
            for(k=0;k<m1.nc;k=k+1){
                mr.t[i][j]= mr.t[i][j]+ m1.t[i][k]*m2.t[k][j];
            }
        }
    }
    return mr;
}

matrice_t sommeMatrices(matrice_t m1, matrice_t m2)
{
    /* renvoie la somme de deux matrices m1 et m2 */
    int i,j;
    matrice_t mr;
    mr=construitMatrice(m1.nl,m1.nc);
    
    for (i=0;i<mr.nl;i++){
        for (j=0;j<mr.nc;j++){
            mr.t[i][j]= m1.t[i][j]+ m2.t[i][j];
        }
    }
    return mr;
}

matrice_t transpose(matrice_t m)
{
    /*	renvoie la transposee d'une matrice m	*/
    int i,j;
    matrice_t mr;
    mr=construitMatrice(m.nc,m.nl);
    for (i=0;i<mr.nl;i++){
        for (j=0;j<mr.nc;j++){
            mr.t[i][j]=m.t[j][i];
        }
    }
    return mr;
}

void calculette()
{
    /* calculette sans me'moire (l'arbre est un peigne gauche */
    matrice_t m1,m2,mr;
    int nl1,nc1;
    int nl2,nc2;
    char ch[2]; // on lira l'operateur dans une chaine de longueur 1
    char op;
    
    //
    printf("nb lignes, nb de colonnes  et elements ?\n");
    scanf("%d",&nl1);
    scanf("%d",&nc1);
    m1=lireMatrice(nl1,nc1);
    printf("operateur ? + * t ou # pour finir\n");
    scanf("%s",ch);op=ch[0];
    while(op != '#'){
        if (op == '+'){

            printf("matrice %d lignes %d colonnes ?\n",m1.nl,m1.nc);
            m2=lireMatrice(m1.nl, m1.nc);
            mr=sommeMatrices(m1,m2);
        }
        else if (op == '*'){
            printf("nb de colonnes de la matrice ? \n");
            scanf("%d",&nc2);
            nl2=m1.nc;
            printf("matrice %d lignes %d colonnes ?\n",nl2,nc2);
            m2=lireMatrice(nl2, nc2);
            mr=produitMatrices(m1,m2);
        }
        else if (op =='t'){
            mr=transpose(m1);
        }
        detruitMatrice(m1); // on libere la memoire allouee au tableau dans m1
        m1=mr;
    
        printf("matrice %d lignes %d colonnes \n",m1.nl,m1.nc);
        afficheMatrice(m1);
        printf("operateur ? + * t ou # pour finir\n");
        scanf("%s",ch);op=ch[0];
    }
    //    afficheMatrice(m1, nl1, nc1);
    return;
}

matrice_t evaluation()
{
    /* calculette avec me'moire (l'arbre est quelconque) */
    /* la fonction est récursive                        */

    char ch[2];
    char op;
    matrice_t m1,m2,m;
    //
    printf("operateur ? + * t ou m pour finir\n");
    scanf("%s",ch);op=ch[0];


    if (op == 'm'){
        printf("nb lignes, nb de colonnes  et elements ?\n");
        scanf("%d",&m.nl);
        scanf("%d",&m.nc);
//        printf("matrice %d lignes %d colonnes ?\n",m1.nl,m1.nc);
        m=lireMatrice(m.nl, m.nc);
    }
    if (op == '+') {
        m1=evaluation();
        m2=evaluation();
        m=sommeMatrices(m1,m2);
        detruitMatrice(m1);
        detruitMatrice(m2);
    }
    if (op == '*') {
        m1=evaluation();
        m2=evaluation();
        m=produitMatrices(m1,m2);
        detruitMatrice(m1);
        detruitMatrice(m2);
    }
    if (op == 't') {
        m1=evaluation();
        m=transpose(m1);
        detruitMatrice(m1);
    }
    printf(" matrice courante \n");
    afficheMatrice(m);
    return m;
}

matrice_t calcul(matrice_t tabMat[], int nombre)
{
    /* calcul matriciel : on un tableau 'tabMat' de  taille 'nombre'
     de matrices   et on entre une  expression bien forme'e parenthe'se'e (ebp) sous forme infixe,
     dans laquelle les matrices sont repre'sente'es par leur
     indice dans tabMat. Exemple : 
     (((0+1)+((0+0)+(1+1)))
    */
    char ch[1000];// contient l'expression, de'but en 0
    matrice_t m; // le resultat
    int pos=0; // la  position de l'e'lement courant dans la chai^ne
    //
    printf("entrez en ordre infixe l'expression\n");
    scanf("%s",ch);
    if(! ebp_c(ch)){
        m.nc=m.nl=0;
        return m;
    }
    m=evaluationChaine(&pos,ch,tabMat);
    return m;
}

matrice_t evaluationChaine(int *apos,char s[],matrice_t tabMat[])
{
    /* Appele'e par 'calcul' evalue l'expression ebp qui commence en (*apos) dans la chai^ne s
     Par exemple dans (((0*1)+((1+1)*(0+1)))t), en 2 commence l'expression (0+1)
     */
    matrice_t m,m1,m2;
    int i,pos;
    pos=(*apos);
    // si '(' calculer une sous-expression
    if (s[pos]=='('){
        (*apos)=(*apos)+1;
        m1=evaluationChaine(apos, s, tabMat);// on evalue l'argument gauche
//        afficheMatrice(m1);
        (*apos)=(*apos)+1;  // on avance d'une position après la position de
                            // fin de l'expression evalue'e en m1
        pos=(*apos);
        if (s[pos]=='+'){//
//             printf("%d\n",(*apos));
            (*apos)=(*apos)+1; // on avance
            m2=evaluationChaine(apos, s, tabMat);
//            afficheMatrice(m2);
            m=sommeMatrices(m1, m2);
        }
        if (s[pos]=='*'){//
            //             printf("%d\n",(*apos));
            (*apos)=(*apos)+1; // on avance
            m2=evaluationChaine(apos, s, tabMat);
            //            afficheMatrice(m2);
            m=produitMatrices(m1, m2);
        }
        if (s[pos]=='t'){//
            m=transpose(m1);
        }

        (*apos)=(*apos)+1; // on lit la ')'
        return m;
    }
    // sinon s[pos] est un entier représentant une matrice
    i= -48+(int)s[pos];
    m=tabMat[i];
    return m;
}

int ebp_c(char s[]){
    // 1 si s contient une ebp 0 sinon
    int p;
    p=ebp(1,s);
    if(p >=1){// l'expression bien forme'e finit en p-1 dans s
        if (s[p]=='\0' ) // pas d'autres caracte`res dans la chai^ne
            return 1;// ebf
        printf("erreur en position %d dans la chaine\n",p);// caracte`re en trop
        return 0;
    }
    printf("erreur en position %d dans la chaine\n",(-p)-1);// erreur dans l'expression
    return 0;
}

int ebp(int p, char s[]){
    /* si ebp commençant en position p (i.e. en s[p-1]) renvoie la position p de 
     fin de l'ebp  ou echec (-p) avec erreur en position p )               */
    // ebp -> symbole entre 0 et 9
    // ebp -> (ebp operateur-unaire)
    // ebp -> (ebp operateur-binaire ebp)
    if (symbole(p,s))
        return p; // ebp
    if (! ouvrante (p,s))
        return -p; // erreur
    p=p+1;// avance
    p=ebp(p,s);
    if(p<0) return p;// erreur
    p=p+1;
    if(op1(p,s)); // oui
    else if(op2(p,s)){ // oui
        p=p+1; p=ebp(p,s); if(p<0) return p; // erreur
    }
    else
        return -p;//erreur
    p=p+1;
    if (! fermante (p,s))
        return -p;// erreur
    return p; // ebp
}

int symbole(int p, char s[]){
    char c;
    c=s[p-1];
    switch (c) {
        case '0': return 1;
        case '1': return 1;
        case '2': return 1;
        case '3': return 1;
        case '4': return 1;
        case '5': return 1;
        case '6': return 1;
        case '7': return 1;
        case '8': return 1;
        case '9': return 1;
        default:
        return 0;
    }
}
int op1(int p, char s[]){
    if (s[p-1]=='t')
        return 1;
    return 0;
}
int op2(int p, char s[]){
    if (s[p-1]=='+' || s[p-1]=='*')
        return 1;
    return 0;
}
int ouvrante(int p, char s[]){
    if (s[p-1]=='(')
        return 1;
    return 0;
}
int fermante(int p, char s[]){
    if (s[p-1]==')')
        return 1;
    return 0;
}
/*
----------
calculette sans me'morisation (peigne gauche) (0) ou
calculette avec me'morisation (1) ou
calcul à partir d'un tableau de matrices et d'une expression (2)
1
nb lignes, nb de colonnes  et elements ?
2 2
1 2
3 4
operateur ? + * t ou # pour finir
*
nb de colonnes de la matrice ?
2
matrice 2 lignes 2 colonnes ?
2 0 
0 2
matrice 2 lignes 2 colonnes
2 4
6 8
operateur ? + * t ou # pour finir
#
Program ended with exit code: 0
--------------
 calculette sans me'morisation (peigne gauche) (0) ou
 calculette avec me'morisation (1) ou
 calcul à partir d'un tableau de matrices et d'une expression (2)
 2
 Calcul matriciel (les sommets de l'arbre en ordre pre'fixe)
 operateur ? + * t ou m pour finir
 +
 operateur ? + * t ou m pour finir
 t
 operateur ? + * t ou m pour finir
 m
 nb lignes, nb de colonnes  et elements ?
 2 2
 1 2
 3 4
 matrice courante
 1 2
 3 4
 matrice courante
 1 3
 2 4
 operateur ? + * t ou m pour finir
 *
 operateur ? + * t ou m pour finir
 +
 operateur ? + * t ou m pour finir
 m
 nb lignes, nb de colonnes  et elements ?
 2 2
 1 2
 3 4
 matrice courante
 1 2
 3 4
 operateur ? + * t ou m pour finir
 m
 nb lignes, nb de colonnes  et elements ?
 2 2
 1 0
 0 1
 matrice courante
 1 0
 0 1
 matrice courante
 2 2
 3 5
 operateur ? + * t ou m pour finir
 m
 nb lignes, nb de colonnes  et elements ?
 2 2
 1 2
 3 4
 matrice courante
 1 2
 3 4
 matrice courante
 8 12
 18 26
 matrice courante
 9 15
 20 30
 Re'sultat du calcul
 9 15 
 20 30 
 Program ended with exit code: 0
 -------------------------
 calculette sans me'morisation (peigne gauche) (1) ou
 calculette avec me'morisation (2) ou
 calcul à partir d'un tableau de matrices et d'une expression (3)
 3
 dimension d'une matrice carrée?
 2 
 matrice 2 lignes 2 colonnes ?
 1 2 
 3 4 
 matrice 2 lignes 2 colonnes ?
 4 3 
 2 1
 expression d'un calcul matriciel sur deux matrices carre'es 0 et 1
 entrez en ordre infixe l'expression
 (+))
 erreur en position 1 dans la chaine
 autre expression  (1) ou fin (0) ?
 1
 expression d'un calcul matriciel sur deux matrices carre'es 0 et 1
 entrez en ordre infixe l'expression
 ((0+1)*((1+1)t))
 70 30
 70 30
 autre expression  (1) ou fin (0) ?
 0
 Program ended with exit code: 0 Program ended with exit code: 0
 */